package org.wfc.user.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.wfc.common.core.domain.LoginUser;
import org.wfc.common.core.domain.R;
import org.wfc.common.core.utils.MessageUtils;
import org.wfc.common.core.utils.StringUtils;
import org.wfc.common.core.utils.file.FileTypeUtils;
import org.wfc.common.core.utils.file.MimeTypeUtils;
import org.wfc.common.core.web.controller.BaseController;
import org.wfc.common.core.web.domain.AjaxResult;
import org.wfc.common.log.annotation.Log;
import org.wfc.common.log.enums.BusinessType;
import org.wfc.common.security.service.TokenService;
import org.wfc.common.security.utils.SecurityUtils;
import org.wfc.user.api.RemoteUFileService;
import org.wfc.user.api.domain.UFile;
import org.wfc.user.api.domain.UUser;
import org.wfc.user.service.IUUserService;

import java.util.Arrays;

/**
 * 个人信息 业务处理
 * 
 * @author wfc
 */
@RestController
@RequestMapping("/user/profile")
public class UProfileController extends BaseController
{
    @Autowired
    private IUUserService userService;
    
    @Autowired
    private TokenService tokenService;
    
    @Autowired
    private RemoteUFileService remoteUFileService;

    /**
     * 个人信息
     */
    @GetMapping
    public AjaxResult profile()
    {
        String username = SecurityUtils.getUsername();
        UUser user = userService.selectUserByUserName(username);
        AjaxResult ajax = AjaxResult.success(user);
        ajax.put("roleGroup", userService.selectUserRoleGroup(username));
        ajax.put("postGroup", userService.selectUserPostGroup(username));
        return ajax;
    }

    /**
     * 修改用户
     */
    // @Log(title = "个人信息", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult updateProfile(@RequestBody UUser user)
    {
        LoginUser<UUser> loginUser = SecurityUtils.getLoginUser();
        UUser currentUser = loginUser.getUser();
        if (user.getNickName() != null) {
            currentUser.setNickName(user.getNickName());
        }
        if (user.getEmail() != null) {
            currentUser.setEmail(user.getEmail());
        }
        if (user.getPhonenumber() != null) {
            currentUser.setPhonenumber(user.getPhonenumber());
        }
        if (user.getSex() != null) {
            currentUser.setSex(user.getSex());
        }
        if (StringUtils.isNotEmpty(user.getPhonenumber()) && !userService.checkPhoneUnique(currentUser))
        {
            return error(MessageUtils.message("user.modify.user.phone.exist", loginUser.getUsername()));
        }
        if (StringUtils.isNotEmpty(user.getEmail()) && !userService.checkEmailUnique(currentUser))
        {        
            return error(MessageUtils.message("user.modify.user.email.exist", loginUser.getUsername()));
        }
        if (userService.updateUserProfile(currentUser))
        {
            // 更新缓存用户信息
            tokenService.setLoginUser(loginUser);
            return success();
        }
        return error(MessageUtils.message("user.modify.user.failed.contact.administrator"));
    }

    /**
     * 重置密码
     */
    // @Log(title = "个人信息", businessType = BusinessType.UPDATE)
    @PutMapping("/updatePwd")
    public AjaxResult updatePwd(String oldPassword, String newPassword)
    {
        String username = SecurityUtils.getUsername();
        UUser user = userService.selectUserByUserName(username);
        String password = user.getPassword();
        if (!SecurityUtils.matchesPassword(oldPassword, password))
        {
            return error(MessageUtils.message("user.modify.password.failed.error.old.password"));
        }
        if (SecurityUtils.matchesPassword(newPassword, password))
        {
            return error(MessageUtils.message("user.modify.password.failed.new.password.same.old.password"));
        }
        newPassword = SecurityUtils.encryptPassword(newPassword);
        if (userService.resetUserPwd(username, newPassword) > 0)
        {
            // 更新缓存用户密码
            LoginUser<UUser> loginUser = SecurityUtils.getLoginUser();
            UUser uuser = loginUser.getUser();
            uuser.setPassword(newPassword);
            loginUser.setUser(uuser);
            tokenService.setLoginUser(loginUser);
            return success();
        }
        return error(MessageUtils.message("user.modify.password.failed.contact.administrator"));
    }
    
    /**
     * 头像上传
     */
    // @Log(title = "用户头像", businessType = BusinessType.UPDATE)
    @PostMapping("/avatar")
    public AjaxResult avatar(@RequestParam("avatarfile") MultipartFile file)
    {
        if (!file.isEmpty())
        {
            LoginUser<UUser> loginUser = SecurityUtils.getLoginUser();
            String extension = FileTypeUtils.getExtension(file);
            if (!StringUtils.equalsAnyIgnoreCase(extension, MimeTypeUtils.IMAGE_EXTENSION))
            {
                return error(MessageUtils.message("user.avatar.file.format.error",
                        Arrays.toString(MimeTypeUtils.IMAGE_EXTENSION)));
            }
            R<UFile> fileResult = remoteUFileService.upload(file);
            if (StringUtils.isNull(fileResult) || StringUtils.isNull(fileResult.getData()))
            {
                return error(MessageUtils.message("user.file.service.error.contact.administrator"));
            }
            String url = fileResult.getData().getUrl();
            if (userService.updateUserAvatar(loginUser.getUsername(), url))
            {
                AjaxResult ajax = AjaxResult.success();
                ajax.put("imgUrl", url);
                // 更新缓存用户头像
                UUser uuser = loginUser.getUser();
                uuser.setAvatar(url);
                loginUser.setUser(uuser);
                tokenService.setLoginUser(loginUser);
                return ajax;
            }
        }
        return error(MessageUtils.message("user.avatar.upload.error.contact.administrator"));
    }
}
